/*
GameCMS_Player_Achievs
	1.2
	* исключение тимкилла
	* изменение метода учета ачивок для ослепленных
	* исправление ачивок с зумом AWP
	
	1.3
	+ добавлено		VarietyHour, //20	Убить врагов из 5 различных видов огнестрельного оружия за один раунд
	* исправлена работа на АМХ 182 (надоело уже, будем избавляться от него)
*/

#include <amxmodx>
#include <cstrike>
#include <hamsandwich>
#include <fakemeta_util>
#include <gamecms_achievs>

new const PLUGIN[] = "GameCMS_Player_Achievs";
new const VERSION[] = "1.3";
new const AUTHOR[] = "zhorzh78";

#if AMXX_VERSION_NUM < 183
	#define BLINDING_TASK_ID	1065
#endif

#define BALLISTIC_TASK_ID	4847
#define m_pActiveItem		373
#define m_iId				43
#define m_flNextAttack		83
#define m_fInReload			54
#define m_fInSpecialReload	55
#define BombDefusing 		(1<<8)
#define m_fBombDefusing		232
#define DEFAULT_FOV			90
#define m_iFOV				363
#define m_iLastZoom			109

enum _:eAchives
{
	BodyBagger = 14,			//14	Убейте 25 врагов
	Corpseman,					//15 	Убейте 500 врагов
	GodofWar,					//16	Убейте 10 000 врагов
	Ballistic,					//17	Убить 5 врагов за 15 секунд
LostandF0wnd,				//18	Убейте противника оружием, которое он бросил в прошлом раунде
	AmmoConservation,			//19	Убить двух противников одной пулей
	VarietyHour,				//20	Убить врагов из 5 различных видов огнестрельного оружия за один раунд
	BattleSightZero,			//21	Убить 250 врагов выстрелами в голову
	ShotWithTheirPants,			//22	Убить врага во время перезарядки
	BlindAmbition,				//23	Убить 25 врагов, ослепленных световой гранатой
	BlindFury,					//24	Убить врага во время ослепления световой гранатой
FriendlyFirearms,			//25	Убить 100 врагов вражеским же оружием
ExpertMarksman,				//26	Убить по одному врагу каждым видом оружия
	Shrapnelproof,				//27	Получить 80 очков урона от вражеских гранат и дожить до конца раунда
	MaketheCut,					//28	Выиграть схватку на ножах
	TheBleedingEdge,			//29	Выиграть 100 схваток на ножах
	DefuseThis,					//30	Убейте игрока, обезвреживающего бомбу, наступательной гранатой
	SafetyFirst,				//31	Выжить после выстрела в голову, потому что хватило ума надеть шлем
	HipSho,						//32	Убить врага из снайперской винтовки без оптического прицела
	EyetoEye,					//33	Убить из снайперской винтовки прицеливающегося вражеского снайпера
	Sknifed	,					//34	Убейте ножом снайпера, использующего оптический прицел
	SnipeHunter,				//35	Убить 100 вражеских снайперов, использующих оптический прицел
	DeadManStalking,			//36	Убить врага, оставшись с 1 очком здоровья
	ThreetheHard,				//37	Убейте 3 врагов одной наступательной гранатой
	StreetFighter,				//38	Убить вражеского игрока ножом во время раунда на пистолетах
	AkimboKing,					//39	Убить с помощью Dual Elites врага, который тоже вооружен Dual Elites
	DeathFromAbove,				//40	Убить врага, находясь в воздухе
	BunnyHunt,					//41	Убить врага, находящегося в воздухе
	AerialNecrobatics,			//42	Находясь в воздухе, убить врага, тоже находящегося в воздухе
RepeatOffender,				//43	Доминировать над вражеским игроком
Decimator,					//44	Доминировать над 10 вражескими игроками
Overkill,					//45	Убить противника, над которым вы уже доминируете
CommandandControl,			//46	Убить 100 раз врагов, над которыми вы доминируете
Insurgent,					//47	Убить вражеского игрока, который над вами доминирует
CantKeepaGoodManDown,		//48	Убить 20 вражеских игроков, которые доминируют над вами
HatTrick,					//49	Доминировать одновременно над тремя вражескими игроками
TenAngryMen,				//50	10 раз за один матч убить вражеских игроков, над которыми вы уже доминируете
ExcessiveBrutality,			//51	Убить вражеского игрока еще 4 раза, когда вы уже доминируете над ним
	SprayandPray,				//52	Убить двух врагов, будучи ослепленным световой гранатой
AvengingAngel				//53	Убить врага в том же раунде, в котором он убил игрока, находящегося в списке ваших друзей
}

public OnAchivesCoreStopped()
	pause("ad");

enum _:tmpStats
{
	kills,
	grenkills,
	BlindKill,
	Float:BlindTimePl,
	Float:grenDmg,
	killWpnNums,
	killWpnBits
}
new gTmpPlStats[MAX_PLAYERS + 1][tmpStats];
new bool:gbFirstRound;

#define	GetBit(%1,%2)		(%1 & 1 << %2)
#define	SetBit(%1,%2)		(%1 |= 1 << %2)

//new cvC4timer, giC4timer, giDropperBomb, giGotterBomb, Float:gfGetBombTimer
//new giBombFromDead, giDefuserWKit, bool:giPlayerAlive[MAX_PLAYERS + 1]

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR);
	RegisterHam(Ham_Spawn, "player", "FwdHamPlayerSpawnPost", 1);
	RegisterHam(Ham_Killed, "player", "FwdHamPlayerKilledPost", 1);
	RegisterHam(Ham_TakeDamage, "player", "FwdHamTakeDamagePost", 1);
	
	register_logevent("Rlog_Round_End", 2, "1=Round_End");
	register_event("TextMsg", "Event_StartGame", "a", "2=#Game_will_restart_in","2=#Game_Commencing");

	#if AMXX_VERSION_NUM < 183
		register_event("ScreenFade", "IsUserBlind", "be", "4=255", "5=255", "6=255", "7>200");
	#else
		RegisterHam(Ham_CS_Player_Blind, "player", "FwdHamCSPlayerBlind");
	#endif
}


public plugin_cfg()
{
	if(is_plugin_loaded("GameCMS_Achievs_Core") == INVALID_PLUGIN_ID)
	{
		log_amx("GameCMS_Achievs_Core is not loaded...");
		pause("ad");
		return;
	}
	
	#if AMXX_VERSION_NUM < 183
		MaxClients = get_maxplayers();
	#endif

	ActivateAchievs();
}

public ActivateAchievs()
{
	for(new i = BodyBagger; i <= AvengingAngel; i++)
		CmsActivateAchive(i);
}

public Event_StartGame()
{
	gbFirstRound = true;
}

public Rlog_Round_End()
{
	if(gbFirstRound)
		gbFirstRound = false;

	for(new i = 1; i <= MaxClients; i++)
	{
		if(!is_user_alive(i))
			continue;

		//27	Получить 80 очков урона от вражеских гранат и дожить до конца раунда
		if(gTmpPlStats[i][grenDmg] >= 80.0)
			CmsCheckPlayerAchive(i, Shrapnelproof);
	}
}

public client_connect(id)
	arrayset(gTmpPlStats[id], 0, tmpStats);

public FwdHamTakeDamagePost(victim, inflictor, attacker, Float:damage, DamageType)
{
	if(pev_valid(attacker) != PDATA_SAFE || pev_valid(victim) != PDATA_SAFE || victim == attacker)
		return HAM_IGNORED;

	if(get_pdata_int(attacker, m_iTeam) == get_pdata_int(victim, m_iTeam))
		return HAM_IGNORED;
	
	if(DamageType == DMG_GRENADE)
		gTmpPlStats[victim][grenDmg] += damage;
		
	if(is_user_alive(victim))
	{
		//31	Выжить после выстрела в голову, потому что хватило ума надеть шлем
		if(DamageType & DMG_BULLET && get_pdata_int(victim, m_LastHitGroup) == HIT_HEAD)
		{
			new CsArmorType:armory;
			cs_get_user_armor(victim, armory);

			if(armory == CS_ARMOR_VESTHELM)
				CmsCheckPlayerAchive(victim, SafetyFirst);
		}
	}

	return HAM_IGNORED;
}

public FwdHamPlayerKilledPost(victim, killer)
{
	ResetTmpStats(victim);
	if(victim == killer)
		return HAM_IGNORED;
	
	if(!is_user_connected(killer))
		return HAM_IGNORED;

	if(!is_valid_player(victim))
		return HAM_IGNORED;

	new CsTeams:iVicTeam = cs_get_user_team(victim);
	if(iVicTeam == CsTeams:get_user_team(killer))
		return HAM_IGNORED;

	static Float:flGameTime, Float:flKillTime;
	flGameTime = get_gametime();
	
	new iInflictor = pev(victim, pev_dmg_inflictor);
	if(iInflictor == killer)
	{
		new iWpnIdKiller, iWpnIdVictim, iWpnEntKiller, iWpnEntVictim;

		iWpnEntKiller = get_pdata_cbase(killer, m_pActiveItem);
		iWpnEntVictim = get_pdata_cbase(victim, m_pActiveItem);
		
		if(pev_valid(iWpnEntKiller) != PDATA_SAFE || pev_valid(iWpnEntVictim) != PDATA_SAFE)
			return HAM_IGNORED;
			
		iWpnIdKiller = get_pdata_int(iWpnEntKiller, m_iId, OFFSET_WEAPON);
		iWpnIdVictim = get_pdata_int(iWpnEntVictim, m_iId, OFFSET_WEAPON);
		
		if(!iWpnIdKiller || !iWpnIdVictim)
			return HAM_IGNORED;

		if(!(GetBit(gTmpPlStats[killer][killWpnBits], iWpnIdKiller)))
		{
			SetBit(gTmpPlStats[killer][killWpnBits], iWpnIdKiller);
			//20	Убить врагов из 5 различных видов огнестрельного оружия за один раунд
			if(++gTmpPlStats[killer][killWpnNums] == 5)
				CmsCheckPlayerAchive(killer, VarietyHour);
		}
		
	//	client_print_color(killer, 0, "Killed by %d, weapon owner %d, team %d | %d", killer, get_pdata_cbase(iWpnEntKiller, 41, 4), get_user_team(victim), get_user_team(killer))
		//16	Убейте 10 000 врагов
		if(CmsCheckPlayerAchive(killer, GodofWar) != AchStatusCompleted)
			//15 	Убейте 500 врагов
			if(CmsCheckPlayerAchive(killer, Corpseman) != AchStatusCompleted)
				//14	Убейте 25 врагов
				CmsCheckPlayerAchive(killer, BodyBagger);

		//21	Убить 250 врагов выстрелами в голову
		if(get_pdata_int(victim, m_LastHitGroup) == HIT_HEAD)
			CmsCheckPlayerAchive(killer, BattleSightZero);
	
		//36	Убить врага, оставшись с 1 очком здоровья
		if(get_user_health(killer) == 1)
			CmsCheckPlayerAchive(killer, DeadManStalking);

		//22	Убить врага во время перезарядки
		if((get_pdata_int(iWpnEntVictim, m_fInReload, OFFSET_WEAPON) || get_pdata_int(iWpnEntVictim, m_fInSpecialReload, OFFSET_WEAPON)) 
			&& get_pdata_float(victim, m_flNextAttack) <= 0.0)
			CmsCheckPlayerAchive(killer, ShotWithTheirPants);
		
		if(iWpnIdKiller == CSW_AWP)
		{
			//32	Убить врага из снайперской винтовки без оптического прицела
			if(get_pdata_int(killer, m_iLastZoom) == DEFAULT_FOV)
				CmsCheckPlayerAchive(killer, HipSho);
		}
			
		if(iWpnIdVictim == CSW_AWP && get_pdata_int(victim, m_iFOV) < DEFAULT_FOV)
		{
			//35	Убить 100 вражеских снайперов, использующих оптический прицел
			CmsCheckPlayerAchive(killer, SnipeHunter);

			//34	Убейте ножом снайпера, использующего оптический прицел
			if(iWpnIdKiller == CSW_KNIFE)
				CmsCheckPlayerAchive(killer, Sknifed);

			//33	Убить из снайперской винтовки прицеливающегося вражеского снайпера	
			if(iWpnIdKiller == CSW_AWP && get_pdata_int(killer, m_iLastZoom) < DEFAULT_FOV)
				CmsCheckPlayerAchive(killer, EyetoEye);
		}
			
		if(iWpnIdKiller == CSW_KNIFE)
		{
			//38	Убить вражеского игрока ножом во время раунда на пистолетах
			if(gbFirstRound)
				CmsCheckPlayerAchive(killer, StreetFighter);

			if(iWpnIdVictim == CSW_KNIFE)
			{
				//29	Выиграть 100 схваток на ножах
				if(CmsCheckPlayerAchive(killer, TheBleedingEdge)   != AchStatusCompleted)
					//28	Выиграть схватку на ножах
					CmsCheckPlayerAchive(killer, MaketheCut);
			}
		}
		
		//39	Убить с помощью Dual Elites врага, который тоже вооружен Dual Elites
		if(iWpnIdKiller == CSW_ELITE)
			if(iWpnIdVictim == CSW_ELITE)
				CmsCheckPlayerAchive(killer, AkimboKing);

		//17	Убить 5 врагов за 15 секунд
		gTmpPlStats[killer][kills]++;
		if(!task_exists(BALLISTIC_TASK_ID + killer))
			set_task(15.0, "CheckBallisticAch", BALLISTIC_TASK_ID + killer);
			
		static bool:inAirVictim;
		inAirVictim = bool:(pev(victim, pev_flags) & FL_FLY);
		
		//40	Убить врага, находясь в воздухе
		if((pev(killer, pev_flags) & FL_FLY))
		{
			CmsCheckPlayerAchive(killer, DeathFromAbove);

			//42	Находясь в воздухе, убить врага, тоже находящегося в воздухе
			if(inAirVictim)
				CmsCheckPlayerAchive(killer, AerialNecrobatics);
		}
		//41	Убить врага, находящегося в воздухе
		else if(inAirVictim)
			CmsCheckPlayerAchive(killer, BunnyHunt);

		//19	Убить двух противников одной пулей
		if(flKillTime == flGameTime)
			CmsCheckPlayerAchive(killer, AmmoConservation);
		
		#if AMXX_VERSION_NUM < 183
		//BlindFury,					//24	Убить врага во время ослепления световой гранатой
		if(task_exists(killer + BLINDING_TASK_ID))
		{
			CmsCheckPlayerAchive(killer, BlindFury);
			
			//SprayandPray,				//52	Убить двух врагов, будучи ослепленным световой гранатой
			if(++gTmpPlStats[killer][BlindKill] > 1)
				CmsCheckPlayerAchive(killer, SprayandPray);
			//BlindAmbition,				//23	Убить 25 врагов, ослепленных световой гранатой
		}
		
		if(task_exists(victim + BLINDING_TASK_ID))
			CmsCheckPlayerAchive(killer, BlindAmbition);
		#else
		//BlindFury,					//24	Убить врага во время ослепления световой гранатой
		if(gTmpPlStats[killer][BlindTimePl] > flGameTime)
		{
			CmsCheckPlayerAchive(killer, BlindFury);
			
			//SprayandPray,				//52	Убить двух врагов, будучи ослепленным световой гранатой
			if(++gTmpPlStats[killer][BlindKill] > 1)
				CmsCheckPlayerAchive(killer, SprayandPray);
		}
		else
			gTmpPlStats[killer][BlindKill] = 0;
		#endif
		
		//BlindAmbition,				//23	Убить 25 врагов, ослепленных световой гранатой
		if(gTmpPlStats[victim][BlindTimePl] > flGameTime)
			CmsCheckPlayerAchive(killer, BlindAmbition);

		///////////////////////////////////////////////////		
	}
	else if(pev_valid(iInflictor))
	{
		if(pev(iInflictor, pev_dmgtime) > 0.0)
		{
			new szClassName[32];
			pev(iInflictor, pev_classname , szClassName, charsmax(szClassName));
			if(equali(szClassName, "grenade"))
			{
				gTmpPlStats[killer][grenkills]++;
	
				//37	Убейте 3 врагов одной наступательной гранатой
				if(flKillTime == flGameTime && gTmpPlStats[killer][grenkills] > 2)
					CmsCheckPlayerAchive(killer, ThreetheHard);
					
				//30	Убейте игрока, обезвреживающего бомбу, наступательной гранатой
				if(get_pdata_int(victim, m_fBombDefusing) & BombDefusing)
					CmsCheckPlayerAchive(killer, DefuseThis);
			}
		}
	}

	flKillTime = flGameTime;
	
	return HAM_IGNORED;
} 

#if AMXX_VERSION_NUM < 183
	public IsUserBlind(id)
	{
		#define ONE_SECOND_OFFSET	4096
		gTmpPlStats[id][BlindKill] = 0;
		set_task(float(read_data(2)/ ONE_SECOND_OFFSET + 1), "UserNotBlind", id + BLINDING_TASK_ID)
	}

	public UserNotBlind(tId)
	{
		new taskID = tId - BLINDING_TASK_ID;
		remove_task(taskID, 1);
		gTmpPlStats[taskID][BlindKill] = 0;
	}
#else
	public FwdHamCSPlayerBlind(id, Float:blindTime, Float:duration, Float:holdTime, alpha)
	{
		if(alpha <= 200)
			return;

		static Float:flGameTime;
		flGameTime = get_gametime();

		if(gTmpPlStats[id][BlindTimePl] < flGameTime)
			gTmpPlStats[id][BlindKill] = 0;
		
		gTmpPlStats[id][BlindTimePl] = flGameTime + blindTime;
	}
#endif

public CheckBallisticAch(TaskId)
{
	new killer = TaskId - BALLISTIC_TASK_ID;
	if(gTmpPlStats[killer][kills] >= 5)
		CmsCheckPlayerAchive(killer, Ballistic);

	remove_task(TaskId, 1)
	gTmpPlStats[killer][kills] = 0;
}
			
ResetTmpStats(id)
{
	arrayset(gTmpPlStats[id], 0, tmpStats);
}

public FwdHamPlayerSpawnPost(id)
{
	if(is_user_alive(id))
		ResetTmpStats(id);
}

public plugin_natives() 
{
	set_native_filter("native_filter");
}

public native_filter(const szName[], index, trap)
	return !trap ? PLUGIN_HANDLED : PLUGIN_CONTINUE;